std::is_trivial(3)

NAME
std::is_trivial - std::is_trivial

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_trivial;
   std::is_trivial is a UnaryTypeTrait.
   If T is a trivial type, provides the member constant value equal to true. For any
   other type, value is false.
   If std::remove_all_extents_t<T> is an incomplete type and not (possibly
   cv-qualified) void, the behavior is undefined.
   If the program adds specializations for std::is_trivial or std::is_trivial_v, the
   behavior is undefined.

Template parameters
   T - a type to check
   Helper variable template
   template< class T > (since C++17)
   inline constexpr bool is_trivial_v = is_trivial<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is a trivial type, false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Example
// Run this code
 #include <type_traits>
 struct A { int m; };
 static_assert(std::is_trivial_v<A> == true);
 struct B { B() {} };
 static_assert(std::is_trivial_v<B> == false);
 int main() {}
   Defect reports
   The following behavior-changing defect reports were applied retroactively to
   previously published C++ standards.
      DR Applied to Behavior as published Correct behavior
   LWG 2015 C++11 T could be an array of incomplete the behavior is
                       class type with unknown bound undefined in this case

See also
   is_trivially_copyable checks if a type is trivially copyable
   (C++11) (class template)
   is_default_constructible
   is_trivially_default_constructible
   is_nothrow_default_constructible checks if a type has a default constructor
   (C++11) (class template)
   (C++11)
   (C++11)